from FX import *
from FX.targets.render_texture import RenderTexture
from Numeric import array
from Convolution import *

blurBuffer = RenderTexture(128,128)

gaussKernel = 1.4*array((0.10, 0.25, 0.25, 0.10))
#offsetLength = 1.3*array((-0.03, -0.01, 0.01, 0.03))
offsetLength = array((-3, -1, 1, 3))

GlowColor = (0.9,0.5,0.1,1.0)

def gaussian1DBlur(x,y):
    vs = convolve4x1D.vs(OffsetDir=(x,y),
                         OffsetLength = offsetLength)
    ps = convolve4x1D.ps(Source = blurBuffer,
                         Coefficients = gaussKernel)
    return ImageProcessing(blurBuffer,
                           VertexShader = vs,
                           FragmentShader = ps)


gaussian2DBlur = 3*[gaussian1DBlur(1,0),gaussian1DBlur(0,1)]

showFS = Cg("""
float4 main(float2 texcoord : TEXCOORD,
            uniform samplerRECT Source) : COLOR
{
   return texRECT(Source, texcoord);
}""")


initialize = [ 
    Target(blurBuffer,ClearColor=(1,1,1,1), Clear=COLOR_BUFFER),
    EndTarget(blurBuffer)]

technique = [
    Render(),
    Target(blurBuffer,Clear=COLOR_BUFFER|DEPTH_BUFFER),
    Render(Color=GlowColor)
    ] + \
    gaussian2DBlur + \
    [
    EndTarget(blurBuffer),
    
    ImageProcessing(blurBuffer,
                    FragmentShader = showFS(Source=blurBuffer),
                    AlphaBlendEnable = True,
                    SrcBlend = SRCALPHA,
                    DestBlend = ONE
                    ),
    ]
